#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "aho-corasick.h"



/* quick test to see if we can construct an interesting tree */
aho_corasick_t* constructTree() {
  aho_corasick_t* tree = malloc(sizeof(aho_corasick_t));
  aho_corasick_init(tree);
  /* if we don't start adding strings, then this will fail with a bus
     error.  I should either fix this, or do something to keep at
     least one string in there as a sentinel. */
  aho_corasick_addstring(tree, "foo");
  aho_corasick_addstring(tree, "bar");
  aho_corasick_addstring(tree, "soylent green");
  aho_corasick_maketree(tree);
  return tree;
}



/* this test is evil and just checks to see if we can read a heck of a lot of keywords. */
/* aho_corasick_t* constructHugeTree() { */
/*   FILE *in; */
/*   aho_corasick_t* tree = malloc(sizeof(aho_corasick_t)); */
/*   char buffer[1024];	 */
/*   char *dynamicspace; */
/*   aho_corasick_init(tree); */
/*   in = fopen("/usr/share/dict/words", "r"); */
/*   while (fscanf(in, "%79s", buffer) != EOF) { */
/*     dynamicspace = malloc(sizeof(char) * (strlen(buffer) + 1)); */
/*     strcpy(dynamicspace, buffer); */
/*     dynamicspace[strlen(buffer)] = '\0'; */
/*     printf("%s\n", dynamicspace); */
/*     aho_corasick_addstring(tree, dynamicspace); */
/*     /\* I'm intentionally leaking memory here: this just a test example.*\/ */
/*   } */
/*   fclose(in); */
/*   printf("done\n"); */
/*   return tree; */
/* } */



void testMatch(aho_corasick_t *tree, char* input) {
  int result;
  char *match;
  char *end;
  result = 
    aho_corasick_nsearch_and_find(tree, input, strlen(input), &match, &end);
  printf("%s: %d, %s, %s\n", input, result, match, end);
}



int main(int argc, char** argv) {
  aho_corasick_t *tree = constructTree();
/*     constructHugeTree(); */

  testMatch(tree, "blah blah");
  testMatch(tree, "this is a test of foo");
  testMatch(tree, "bar a blah said this.");
  testMatch(tree, "don't you know that soylent green is people?");
  aho_corasick_destroy(tree);
  return 0;
}
